using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Optimization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Analysis {

  [Item("IntArraySnapshotCreaterAnalyzer", "An operator that adds lightweight snapshots to all IntArray`s for later analysis.")]
  [StorableClass]
  public sealed class IntArraySnapshotCreaterAnalyzer : SnapshotCreaterAnalyzer<int>, IAnalyzer {

    [StorableConstructor]
    private IntArraySnapshotCreaterAnalyzer(bool deserializing) : base(deserializing) { }
    private IntArraySnapshotCreaterAnalyzer(IntArraySnapshotCreaterAnalyzer original, Cloner cloner) : base(original, cloner) { }
    public IntArraySnapshotCreaterAnalyzer() { }
    public override IDeepCloneable Clone(Cloner cloner) { return new IntArraySnapshotCreaterAnalyzer(this, cloner); }
  }
}